package chap10;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;

public class AddressBookTag2 extends BodyTagSupport{
  private String name;
/*java.util.Enumeration ó Collection ü .
  Ѱ ͸ ϱ ؼ...
  java.util.Enumeration java.util.Iterator 
   Ʈ   ִ ִٴ ̴. */
  private Iterator iterator;
  private String type;

//************** setter ޼ҵ *************************
  public void setCollection(Collection collection){
//Collection Ʈ  ִ üũ   
	if(collection.size()>0) 
      iterator = collection.iterator();
  }

  public void setName(String name)
  {
    this.name=name;
  }
  public void setType(String type){
	this.type=type; 
  }
//******************************************************

  public int doStartTag(){
//iterator Ʈ ٸ ٵ  Ѵ.
	if(iterator==null) {
      return SKIP_BODY;
    }
//iterator Ʈ ִٸ  Ʈ ´.
    if(iterator.hasNext()) {
// ̸ ϴ pageContext  ü ߰Ѵ.   
      pageContext.setAttribute(name,iterator.next(),PageContext.PAGE_SCOPE);
      return EVAL_BODY_TAG;
    }
    else{
      return SKIP_BODY;
    }
  }

  public int doAfterBody() throws JspException{
//iterator Ʈ ִٸ  Ʈ ´.
    if(iterator.hasNext()){
// ̸ ϴ pageContext  ü ߰Ѵ. 
      pageContext.setAttribute(name,iterator.next(),PageContext.PAGE_SCOPE);
      return EVAL_BODY_TAG;
    }
    else{
      return SKIP_BODY;
    }
  }
 
  public int doEndTag() throws JspException{
    try{
//ٵ  null ƴ϶(ٵ  ߴٸ) Ѵ.
      if(bodyContent != null) 
        bodyContent.writeOut(bodyContent.getEnclosingWriter());
    }
    catch(java.io.IOException e)
    {
      throw new JspException("IO Error: " + e.getMessage());
    }
    return EVAL_PAGE;
  }
}